/**
 * Examples/GUI/SimpleGUI/SimpleGUI.cpp
 *
 * If you edit this example, please also update the wiki and source code file in the repository.
 */
#include "TUBEGUI.hpp"
#include <FAST/Importers/ImageFileImporter.hpp>
#include <FAST/Visualization/MeshRenderer/MeshRenderer.hpp>
#include "FAST/Exporters/ImageExporter.hpp"
//#include "FAST/Visualization/ImageRenderer/ImageRenderer.hpp"
#include "FAST/Exporters/ImageExporter.hpp"
#include <boost/bind.hpp>
#include "FAST/TestDataPath.hpp"
#include <QHBoxLayout>
#include <FAST/Visualization/SliceRenderer/SliceRenderer.hpp>
#include "FAST/Visualization/LineRenderer/LineRenderer.hpp"
#include "FAST/Algorithms/CASACLE/CASACLE.hpp"
#include <iostream>
#include <fstream>

namespace fast {

TUBEGUI::TUBEGUI() {

    //viewOrig = createView();
    //viewOrig->set3DMode();
    //viewOrig->set3DMode();
    // Create a 3D view
    //View* view = createView();
    view = createView();
    view->set3DMode();
    //view->set2DMode();
    enableFullscreen();

    // Import image
    ImageFileImporter::pointer importer = ImageFileImporter::New();
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/CT-Abdomen.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image10.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image00.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image02.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/coronary_ct_cropped.mhd");
    //Importers
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image00.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image01.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image02.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image03.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image04.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image05.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image06.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image07.mhd");

    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image09.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image10.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image11.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image12.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image13.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image14.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image15.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image16.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image17.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image18.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image19.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image20.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image21.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image22.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image23.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image24.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image25.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image26.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image27.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image28.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image29.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image30.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/image31.mhd");

    //StOlavs
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/stolavs01.mhd");
    importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/stolavs02.mhd"); //denne
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/stolavs03.mhd");
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/stolavs04.mhd"); //denne
    //importer->setFilename(std::string(FAST_TEST_DATA_DIR) + "/stolavs12.mhd");//no included
    /*
    //TubeExtract
    TubeSegmentationAndCenterlineExtraction::pointer tubeExtraction = TubeSegmentationAndCenterlineExtraction::New();
    tubeExtraction->setInputConnection(importer->getOutputPort());
    tubeExtraction->extractBrightTubes();
    //tubeExtraction->disableSegmentation();

    tubeExtraction->setMaximumRadius(6);
    tubeExtraction->setRadiusStep(0.5);
    tubeExtraction->setMinimumRadius(0.5);
    tubeExtraction->setMinimumIntensity(100);
    tubeExtraction->setMaximumIntensity(300);
    */

    //CASACLE
    //Image::pointer temp = importer->getOutputData<Image>();
    //Image::pointer inputMIP = Image::New();
    //inputMIP->create(temp->getSize.x(),temp->getSize.y(),TYPE_FLOAT,1);

    CASACLE::pointer centerLineExtraction = CASACLE::New();
    centerLineExtraction->setInputConnection(importer->getOutputPort());
    //centerLineExtraction->setInputData(inputMIP);
    centerLineExtraction->extractBrightTubes();
    centerLineExtraction->setMaximumRadius(5);
    centerLineExtraction->setRadiusStep(0.2);
    centerLineExtraction->setMinimumRadius(0.2);
    //centerLineExtraction->setMaximumIntensity(300);
    //centerLineExtraction->setMinimumIntensity(100);
    centerLineExtraction->setMaximumIntensity(500);
    centerLineExtraction->setMinimumIntensity(0);
    //centerLineExtraction->setSensitivity(0.75);
    centerLineExtraction->setSensitivity(1);
    
    //For testing of StOlavs
    centerLineExtraction->enableCropping();
    centerLineExtraction->setCroppingFraction(0.135);
    //centerLineExtraction->enableStOlavsFix();
    //NLM
    //centerLineExtraction->enableNLM();
    //centerLineExtraction->setNLMGroup(3);
    //centerLineExtraction->setNLMWindow(5);
    //centerLineExtraction->setNLMSigma(0.65f);
    //centerLineExtraction->setNLMStrength(0.35f);

    //Gaussian
    centerLineExtraction->enableGaussian();
    centerLineExtraction->setGaussianStrength(1.2f);

    //SliceRenderer::pointer renderer = SliceRenderer::New();
    //renderer->setInputConnection(importer->getOutputPort());
    centerLineExtraction->update();
    /*
    LineRenderer::pointer lineRenderer = LineRenderer::New();
    //lineRenderer->addInputConnection(tubeExtraction->getCenterlineOutputPort());
    lineRenderer->addInputConnection(centerLineExtraction->getCenterlineOutputPort());
    //LineSet::pointer centerlines = centerLineExtraction->getOutputData<LineSet>();
    lineRenderer->setDefaultDrawOnTop(true);
    view->addRenderer(lineRenderer);
    */
    SurfaceExtraction::pointer surfaceExtraction = SurfaceExtraction::New();
    surfaceExtraction->setInputConnection(centerLineExtraction->getSegmentationOutputPort());

    MeshRenderer::pointer meshRenderer = MeshRenderer::New();
    meshRenderer->addInputConnection(surfaceExtraction->getOutputPort());

    view->addRenderer(meshRenderer);
    
    QHBoxLayout* layout = new QHBoxLayout;
    //layout->addLayout(menuLayout);
    //layout->addWidget(viewOrig);
    layout->addWidget(view);

    mWidget->setLayout(layout);
    /*
    ImageExporter::pointer exporter = ImageExporter::New();
    exporter->setFilename("tubeguiMIP.jpg");
    exporter->setInputConnection(centerLineExtraction->getMIPOutputPort());
    exporter->update();
    */
}
    
}
