/**
 * Examples/GUI/SimpleGUI/SimpleGUI.hpp
 *
 * If you edit this example, please also update the wiki and source code file in the repository.
 */
#ifndef TUBE_GUI_HPP_
#define TUBE_GUI_HPP_

#include "FAST/Visualization/Window.hpp"
#include "FAST/Algorithms/SurfaceExtraction/SurfaceExtraction.hpp"
#include "FAST/Visualization/ImageRenderer/ImageRenderer.hpp"
#include "FAST/Visualization/LineRenderer/LineRenderer.hpp"
#include "FAST/Algorithms/TubeSegmentationAndCenterlineExtraction/TubeSegmentationAndCenterlineExtraction.hpp"
#include "FAST/Visualization/MeshRenderer/MeshRenderer.hpp"
#include "FAST/Exporters/ImageExporter.hpp"
#include <QHBoxLayout>

namespace fast {

class TUBEGUI : public Window {
	FAST_OBJECT(TUBEGUI)
	public:
	private:
		TUBEGUI();
        TubeSegmentationAndCenterlineExtraction::pointer tubeExtraction;
        SurfaceExtraction::pointer surfaceExtraction;
        MeshRenderer::pointer meshRenderer;
        LineRenderer::pointer lineRenderer;
        ImageRenderer::pointer renderer;
        ImageExporter::pointer exporter;
        View* view;
        QHBoxLayout* layout;
    
};

} // end namespace fast

#endif
